<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__pdm__pcm" kind="group">
    <compoundname>group_pdm_pcm</compoundname>
    <title>PDM_PCM      (PDM-PCM Converter)</title>
    <innergroup refid="group__group__pdm__pcm__macros">Macros</innergroup>
    <innergroup refid="group__group__pdm__pcm__functions">Functions</innergroup>
    <innergroup refid="group__group__pdm__pcm__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__pdm__pcm__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>The pulse-density modulation to pulse-code modulation (PDM-PCM) driver provides an API to manage PDM-PCM conversion. </para>    </briefdescription>
    <detaileddescription>
<para>A PDM-PCM converter is used to convert 1-bit digital audio streaming data to PCM data.</para><para>The functions and other declarations used in this driver are in cy_pdm_pcm.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>Features:<itemizedlist>
<listitem><para>Supports FIFO buffer for Incoming Data</para></listitem><listitem><para>Supports Software Mute Mode</para></listitem><listitem><para>Programmable Gain Settings</para></listitem><listitem><para>Programmable Word Length</para></listitem></itemizedlist>
</para><para>Pulse-density modulation, or PDM, represents an analog signal with a binary signal. In a PDM signal, specific amplitude values are not encoded into codewords of pulses of different weight as they would be in pulse-code modulation (PCM); rather, the relative density of the pulses corresponds to the analog signal's amplitude. The output of a 1-bit DAC is the same as the PDM encoding of the signal.</para><para>Pulse-code modulation (PCM) is the method used to digitally represent sampled analog signals. It is the standard form of digital audio in computers, compact discs, digital telephony, and other digital audio applications. In a PCM stream, the amplitude of the analog signal is sampled regularly at uniform intervals, and each sample is quantized to the nearest value within a range of digital steps.</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>To set up a PDM-PCM, provide the configuration parameters in the <ref kindref="compound" refid="structcy__stc__pdm__pcm__config__t">cy_stc_pdm_pcm_config_t</ref> structure.</para><para>For example, set dataStreamingEnable to true, configure rxFifoTriggerLevel, dmaTriggerEnable (depending on whether DMA is going to be used), provide clock settings (clkDiv, mclkDiv and ckoDiv), set sincDecRate to the appropriate decimation rate, wordLen, and wordBitExtension. No other parameters are necessary for this example.</para><para>To initialize the PDM-PCM block, call the <ref kindref="member" refid="group__group__pdm__pcm__functions_1ga72f994cbd634988b0016f464720b3559">Cy_PDM_PCM_Init</ref> function, providing the filled <ref kindref="compound" refid="structcy__stc__pdm__pcm__config__t">cy_stc_pdm_pcm_config_t</ref> structure.</para><para>If you use a DMA, the DMA channel should be previously configured. PDM-PCM interrupts (if applicable) can be enabled by calling <ref kindref="member" refid="group__group__pdm__pcm__functions_1gaecd6316cef42b4c9d31b38aad0c222e6">Cy_PDM_PCM_SetInterruptMask</ref>.</para><para>For example, if the trigger interrupt is used during operation, the ISR should call the <ref kindref="member" refid="group__group__pdm__pcm__functions_1ga93d86ba7f06b583502f1300eafde9783">Cy_PDM_PCM_ReadFifo</ref> as many times as required for your FIFO payload. Then call <ref kindref="member" refid="group__group__pdm__pcm__functions_1ga9519b93d2271e63fc4fbce99cc555d5e">Cy_PDM_PCM_ClearInterrupt</ref> with appropriate parameters.</para><para>If a DMA is used and the DMA channel is properly configured, no CPU activity (or application code) is needed for PDM-PCM operation.</para>

<para><heading level="1">More Information</heading></para>
<para>See: the PDM-PCM chapter of the device technical reference manual (TRM); the PDM_PCM_PDL Component datasheet; CE219431 - PSOC 6 MCU PDM-TO-PCM EXAMPLE.</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The PDM-PCM driver has the following specific deviations: <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;10.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A composite expression of the "essentially unsigned" type is cast to a different type category. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The value got from the bitfield physically can't exceed the enumeration that describes this bitfield. So the code is safe by design.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast should not be performed between a pointer to the object type and a different pointer to the object type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The function &lt;a href="group__group__pdm__pcm__functions.html#group__group__pdm__pcm__functions_1ga83e3fa66567ae8e8ee284f3315673cec"&gt;Cy_PDM_PCM_DeepSleepCallback&lt;/a&gt; is a callback of &lt;a href="group__group__syspm__data__enumerates.html#group__group__syspm__data__enumerates_1ga601b1cb722cb091133caf33d8ab235ca"&gt;cy_en_syspm_status_t&lt;/a&gt; type. The cast operation safety in this function becomes the user responsibility because the pointer is initialized when a callback is registered in SysPm driver.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.20.2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.20.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Snippet updated. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Old snippet outdated.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;2.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The gain values in range +4.5...+10.5dB (5 items) of /ref cy_en_pdm_pcm_gain_t are corrected. Added Low Power Callback section. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Incorrect setting of gain values in limited range. Documentation update and clarification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enumeration types for gain and soft mute cycles are added.&lt;br /&gt; Function parameter checks are added.&lt;br /&gt; The next functions are removed:&lt;ul&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_EnterLowPowerCallback&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_ExitLowPowerCallback&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_EnableDataStream&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_DisableDataStream&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_SetFifoLevel&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_GetFifoLevel&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_EnableDmaRequest&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_DisableDmaRequest&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;p&gt;The next functions behaviour are modified:&lt;ul&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_Enable&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_Disable&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_SetInterruptMask&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_GetInterruptMask&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_GetInterruptStatusMasked&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_GetInterruptStatus&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_ClearInterrupt&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Cy_PDM_PCM_SetInterrupt&lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;p&gt;The Cy_PDM_PCM_GetFifoNumWords function is renamed to Cy_PDM_PCM_GetNumInFifo.&lt;br /&gt; The Cy_PDM_PCM_GetCurrentState function is added.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improvements based on usability feedbacks.&lt;br /&gt; API is reworked for consistency within the PDL.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>